var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

// src/styled.tsx
import { Fragment as _Fragment, createVNode as _createVNode, isVNode as _isVNode } from "vue";
import clsx from "clsx";
import { mergeProps } from "vue";
import { serializeStyles } from "@emotion/serialize";
import { extractStyleAttrs } from "@chakra-ui/vue-utils";
import { getRegisteredStyles, insertStyles } from "@emotion/utils";
import camelCase from "lodash.camelcase";

// src/types.ts
import "vue";

// src/tags.ts
var tags = [
  "a",
  "abbr",
  "address",
  "area",
  "article",
  "aside",
  "audio",
  "b",
  "base",
  "bdi",
  "bdo",
  "big",
  "blockquote",
  "body",
  "br",
  "button",
  "canvas",
  "caption",
  "cite",
  "code",
  "col",
  "colgroup",
  "data",
  "datalist",
  "dd",
  "del",
  "details",
  "dfn",
  "dialog",
  "div",
  "dl",
  "dt",
  "em",
  "embed",
  "fieldset",
  "figcaption",
  "figure",
  "footer",
  "form",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "head",
  "header",
  "hgroup",
  "hr",
  "html",
  "i",
  "iframe",
  "img",
  "input",
  "ins",
  "kbd",
  "keygen",
  "label",
  "legend",
  "li",
  "link",
  "main",
  "map",
  "mark",
  "marquee",
  "menu",
  "menuitem",
  "meta",
  "meter",
  "nav",
  "noscript",
  "object",
  "ol",
  "optgroup",
  "option",
  "output",
  "p",
  "param",
  "picture",
  "pre",
  "progress",
  "q",
  "rp",
  "rt",
  "ruby",
  "s",
  "samp",
  "script",
  "section",
  "select",
  "small",
  "source",
  "span",
  "strong",
  "style",
  "sub",
  "summary",
  "sup",
  "table",
  "tbody",
  "td",
  "textarea",
  "tfoot",
  "th",
  "thead",
  "time",
  "title",
  "tr",
  "track",
  "u",
  "ul",
  "var",
  "video",
  "wbr",
  "circle",
  "clipPath",
  "defs",
  "ellipse",
  "foreignObject",
  "g",
  "image",
  "line",
  "linearGradient",
  "mask",
  "path",
  "pattern",
  "polygon",
  "polyline",
  "radialGradient",
  "rect",
  "stop",
  "svg",
  "text",
  "tspan"
];

// src/cache.tsx
import createCache from "@emotion/cache";
import "@emotion/utils";
import { createContext, canUseDOM } from "@chakra-ui/vue-utils";
import "vue";
var [EmotionCacheProvider, useEmotionCache, EmotionCacheInjectionSymbol] = createContext({
  strict: false,
  name: "EmotionCacheContext"
});
var defaultCache = createCache({
  key: "chakra"
});
var __unusafe_useEmotionCache = useEmotionCache;
var withEmotionCache = /* @__PURE__ */ __name(function withEmotionCache2(fn) {
  return (p) => {
    const cache = useEmotionCache(defaultCache);
    return fn(cache);
  };
}, "withEmotionCache");
if (canUseDOM()) {
  withEmotionCache = /* @__PURE__ */ __name(function withEmotionCache3(fn) {
    return () => {
      const cache = useEmotionCache(defaultCache);
      if (!cache) {
        const cache2 = createCache({
          key: "chakra"
        });
        EmotionCacheProvider(cache2);
        return fn(cache2);
      } else {
        return fn(cache);
      }
    };
  }, "withEmotionCache");
}

// src/theming.tsx
import weakMemoize from "@emotion/weak-memoize";
import { createContext as createContext2 } from "@chakra-ui/vue-utils";

// src/utils.ts
var getTheme = /* @__PURE__ */ __name((outerTheme, theme) => {
  if (typeof theme === "function") {
    const mergedTheme = theme(outerTheme);
    if (process.env.NODE_ENV !== "production" && (mergedTheme == null || typeof mergedTheme !== "object" || Array.isArray(mergedTheme))) {
      throw new Error("[EmotionThemeProvider] Please return an object from your theme function, i.e. theme={() => ({})}!");
    }
    return mergedTheme;
  }
  if (process.env.NODE_ENV !== "production" && (theme == null || typeof theme !== "object" || Array.isArray(theme))) {
    throw new Error("[EmotionThemeProvider] Please make your theme prop a plain object");
  }
  return {
    ...outerTheme,
    ...theme
  };
}, "getTheme");

// src/theming.tsx
import "vue";
var [_EmotionThemeProvider, useEmotionTheme, EmotionThemeContextSymbol] = createContext2({
  strict: false,
  name: "EmotionThemeContext"
});
var createCacheWithTheme = /* @__PURE__ */ weakMemoize((outerTheme) => {
  return weakMemoize((theme) => {
    return getTheme(outerTheme, theme);
  });
});
function EmotionThemeProvider(theme) {
  let _theme = useEmotionTheme();
  if (theme !== _theme) {
    _theme = createCacheWithTheme(_theme)(theme);
  }
  _EmotionThemeProvider(_theme);
}
__name(EmotionThemeProvider, "EmotionThemeProvider");

// src/styled.tsx
import memoize from "lodash.memoize";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var ILLEGAL_ESCAPE_SEQUENCE_ERROR = `You have illegal escape sequence in your template literal, most likely inside content's property value.
Because you write your CSS inside a JavaScript string you actually have to do double escaping, so for example "content: '\\00d7';" should become "content: '\\\\00d7';".
You can read more about this here:
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences`;
var isBrowser = typeof document !== "undefined";
var Noop = /* @__PURE__ */ __name(() => null, "Noop");
var camelCaseCache = {};
var _camelCase = memoize((key) => camelCase(key));
var createStyled = /* @__PURE__ */ __name((tag, options) => {
  if (process.env.NODE_ENV !== "production") {
    if (tag === void 0) {
      throw new Error("You are trying to create a styled element with an undefined component.\nYou may have forgotten to import it.");
    }
  }
  const isReal = tag.__emotion_real === tag;
  const baseTag = isReal && tag.__emotion_base || tag;
  let identifierName;
  let targetClassName;
  if (options !== void 0) {
    identifierName = options.__label;
    targetClassName = options.target;
  }
  return function() {
    let args = arguments;
    let styles = isReal && tag.__emotion_styles !== void 0 ? tag.__emotion_styles.slice(0) : [];
    if (identifierName !== void 0) {
      styles.push(`label:${identifierName};`);
    }
    if (args[0] == null || args[0].raw === void 0) {
      styles.push.apply(styles, args);
    } else {
      if (process.env.NODE_ENV !== "production" && args[0][0] === void 0) {
        console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
      }
      styles.push(args[0][0]);
      let len = args.length;
      let i = 1;
      for (; i < len; i++) {
        if (process.env.NODE_ENV !== "production" && args[0][i] === void 0) {
          console.error(ILLEGAL_ESCAPE_SEQUENCE_ERROR);
        }
        styles.push(args[i], args[0][i]);
      }
    }
    function StyledComponent(props, {
      attrs,
      expose,
      slots
    }) {
      const cache = __unusafe_useEmotionCache(defaultCache);
      const {
        as,
        ...restAttrs
      } = attrs || {};
      let mergedProps = {
        ...props,
        ...restAttrs
      };
      let className = (options == null ? void 0 : options.__label) ? `${cache.key}-${(options == null ? void 0 : options.__label) || typeof tag === "string" ? tag : "element"} ` : ``;
      const FinalTag = as || baseTag;
      const classInterpolations = [];
      mergedProps = {};
      for (let key in props) {
        if (camelCaseCache[key]) {
          mergedProps[key] = camelCaseCache[key];
        } else {
          const attr = _camelCase(key);
          camelCaseCache[attr] = props[key];
          mergedProps[attr] = props[key];
        }
      }
      if (props.theme == null) {
        mergedProps.theme = useEmotionTheme(void 0);
      }
      mergedProps = mergeProps({
        ...attrs,
        ...mergedProps
      });
      if (attrs.class) {
        className += getRegisteredStyles(cache.registered, classInterpolations, clsx(attrs.class));
      }
      const serialized = serializeStyles(styles.concat(classInterpolations), cache.registered, mergedProps);
      const rules = insertStyles(cache, serialized, typeof FinalTag === "string");
      className += `${cache.key}-${serialized.name}`;
      if (targetClassName !== void 0) {
        className += ` ${targetClassName}`;
      }
      const {
        attrs: htmlAttrs
      } = extractStyleAttrs(mergedProps);
      const vnodeProps = {
        ...htmlAttrs,
        class: className
      };
      vnodeProps == null ? true : delete vnodeProps.theme;
      const StyledElement = _createVNode(FinalTag, vnodeProps, _isSlot(slots) ? slots : {
        default: () => [slots]
      });
      let possiblyStyleElement = _createVNode(Noop, null, null);
      if (!isBrowser && rules !== void 0) {
        let serializedNames = serialized.name;
        let next = serialized.next;
        while (next !== void 0) {
          serializedNames += " " + next.name;
          next = next.next;
        }
        possiblyStyleElement = _createVNode("style", {
          [`data-emotion`]: `${cache.key} ${serializedNames}`,
          nonce: cache.sheet.nonce
        }, [rules]);
      }
      return _createVNode(_Fragment, null, [possiblyStyleElement, StyledElement]);
    }
    __name(StyledComponent, "StyledComponent");
    StyledComponent._name = identifierName === void 0 ? `Styled${typeof baseTag === "string" ? baseTag : baseTag.name || "Component"}` : identifierName;
    StyledComponent.__emotion_real = StyledComponent;
    StyledComponent.__emotion_base = baseTag;
    StyledComponent.__emotion_styles = styles;
    Object.defineProperty(StyledComponent, "toString", {
      value() {
        if (targetClassName === void 0 && process.env.NODE_ENV !== "production") {
          return "NO_COMPONENT_SELECTOR";
        }
        return `.${targetClassName}`;
      }
    });
    StyledComponent.withComponent = (nextTag, nextOptions) => {
      return createStyled(
        nextTag,
        nextOptions === void 0 ? options : {
          ...options || {},
          ...nextOptions
        }
      ).apply(null, styles);
    };
    return StyledComponent;
  };
}, "createStyled");

// src/index.tsx
var styled = createStyled.bind();
tags.forEach((tagName) => {
  styled[tagName] = styled(tagName);
});
var src_default = styled;
export {
  EmotionCacheInjectionSymbol,
  EmotionCacheProvider,
  EmotionThemeContextSymbol,
  EmotionThemeProvider,
  __unusafe_useEmotionCache,
  createCacheWithTheme as createThemeCache,
  src_default as default,
  defaultCache,
  useEmotionTheme,
  withEmotionCache
};
